package com.frotscher.example.euro2016.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class GroupStandings {

	class Position {

		public Position() {}
		
		public Position(Team team, Integer points, Integer goalsForTeam, Integer goalsAgainstTeam) {
			this.team = team;
			this.points = points;
			this.goalsForTeam = goalsForTeam;
			this.goalsAgainstTeam = goalsAgainstTeam;
		}
		
		private Team team;
		private Integer points;
		private Integer goalsForTeam;
		private Integer goalsAgainstTeam;

		public Team getTeam() {
			return team;
		}
		
		public void setTeam(Team team) {
			this.team = team;
		}
		
		public Integer getPoints() {
			return points;
		}
		
		public void setPoints(Integer points) {
			this.points = points;
		}
		
		public Integer getGoalsForTeam() {
			return goalsForTeam;
		}
		
		public void setGoalsForTeam(Integer goalsForTeam) {
			this.goalsForTeam = goalsForTeam;
		}
		
		public Integer getGoalsAgainstTeam() {
			return goalsAgainstTeam;
		}
		
		public void setGoalsAgainstTeam(Integer goalsAgainstTeam) {
			this.goalsAgainstTeam = goalsAgainstTeam;
		}
		
		public Integer getGoalDifference() {
			return goalsForTeam - goalsAgainstTeam;
		}
	}

	
	private List<Position> positions;

	public List<Position> getPositions() {
		Collections.sort(positions, new PositionComparator());
		return positions;
	}

	public void setPositions(List<Position> positions) {
		this.positions = positions;
	}
	
	public void addPosition(Position position) {
		if (positions==null) {
			positions = new ArrayList<>();
		}
		positions.add(position);
	}
	
	
	private class PositionComparator implements Comparator<Position> {
		@Override
		public int compare(Position p1, Position p2) {
			
			int points = p2.getPoints().compareTo(p1.getPoints());
			if (points!=0) {
				return points;
			}

			int goalDiff = p2.getGoalDifference().compareTo(p1.getGoalDifference());
			if (goalDiff!=0) {
				return goalDiff;
			}

			int goalsFor = p2.getGoalsForTeam().compareTo(p1.getGoalsForTeam());
			return goalsFor;
		}
		
	}
}