package com.frotscher.example.euro2016.mvc.controller;

import javax.inject.Inject;
import javax.mvc.Models;
import javax.mvc.Viewable;
import javax.mvc.annotation.Controller;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;

import org.glassfish.ozark.ext.thymeleaf.ThymeleafViewEngine;

import com.frotscher.example.euro2016.model.Stage;
import com.frotscher.example.euro2016.mvc.ErrorDetails;
import com.frotscher.example.euro2016.repository.StageRepository;

@Path("stages")
public class StageController {

	@Inject
	private StageRepository stageRepo;
	
	@Inject
	private Models models;
	
	@Inject
	private ErrorDetails errorDetails;

	@GET
    @Path("{stageId}")
    @Controller
    public Viewable getStage(@PathParam("stageId") Integer stageNumber) {
    	Stage stage = stageRepo.getStage(stageNumber);

    	models.put("stage", stage);
        models.put("errors", errorDetails);

        Viewable viewable = new Viewable("stage" + stageNumber + ".html", models, ThymeleafViewEngine.class);
        return viewable;
    }
}